unit dd55u1;

(*Tested in early Apr 2010, using Windows XP and Delphi4.
Worked fine to send X or Y to an Arduino. See....
http://sheepdogguides.com/arduino/ahttoc.htm
(Probably in "Level 4" for more information on the
Arduino end of things.*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDD55f1 = class(TForm)
    buSendX: TButton;
    buSendY: TButton;
    buCloseConnection: TButton;
    buQuit: TButton;
    buOpenConnection: TButton;
    procedure buQuitClick(Sender: TObject);
    procedure buOpenConnectionClick(Sender: TObject);
    procedure buSendXClick(Sender: TObject);
    procedure buSendYClick(Sender: TObject);
  private
    { Private declarations }
    hCommFile : THandle;
    procedure WriteString(sToSend:string);
  public
    { Public declarations }
  end;

var
  DD55f1: TDD55f1;

implementation

{$R *.DFM}

procedure TDD55f1.buQuitClick(Sender: TObject);
begin
application.terminate;
end;

procedure TDD55F1.WriteString(sToSend:string);
var NumberWritten : dWord;
  {N.B.: I saw the following in a newsgroup post:
  "Warning: There is an error in the FAQ - NumberWritten must be
  dword not LongInt"}
begin
if WriteFile(hCommFile,
               PChar(sToSend)^,
               Length(sToSend),
               NumberWritten,
               nil)=false then
      showmessage('Unable to send');
end;

procedure TDD55f1.buOpenConnectionClick(Sender: TObject);
var
  CommPort : string;
begin
  CommPort := 'COM1';
  hCommFile := CreateFile(PChar(CommPort),
                          GENERIC_WRITE,
                          0,
                          nil,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          0);
  if hCommFile=INVALID_HANDLE_VALUE then begin
      ShowMessage('Unable to open '+ CommPort);
      end // no ; here
      else begin
      buSendX.enabled:=true;
      buSendY.enabled:=true;
      buCloseConnection.enabled:=true;
      buOpenConnection.enabled:=false;
      end; //else
end;

procedure TDD55F1.buSendXClick(Sender: TObject);
begin
WriteString('X');
end;


procedure TDD55F1.buSendYClick(Sender: TObject);
begin
WriteString('Y');
end;


end.
